VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsCapturePicker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 08/2022

Option Explicit

' ----==== Const ====----
Private Const S_OK As Long = &H0&
Private Const API_TRUE As Long = &H1&
Private Const GWL_STYLE As Long = -16
Private Const CC_STDCALL As Long = &H4&
Private Const WS_MINIMIZE As Long = &H20000000
Private Const GdiPlusVersion As Long = &H1&

Private Const CLSID_GDIPBmpEncoder As String = "{557cf400-1a04-11d3-9a73-0000f81ef32e}"
Private Const CLSID_GDIPJpgEncoder As String = "{557cf401-1a04-11d3-9a73-0000f81ef32e}"
Private Const CLSID_GDIPGifEncoder As String = "{557cf402-1a04-11d3-9a73-0000f81ef32e}"
Private Const CLSID_GDIPTifEncoder As String = "{557cf405-1a04-11d3-9a73-0000f81ef32e}"
Private Const CLSID_GDIPPngEncoder As String = "{557cf406-1a04-11d3-9a73-0000f81ef32e}"

Private Const D3D_DRIVER_TYPE_HARDWARE As Long = &H1&
Private Const D3D11_SDK_VERSION As Long = &H7&
Private Const D3D11_CREATE_DEVICE_BGRA_SUPPORT As Long = &H20&

Private Const IID_IClosable As String = "{30d5a829-7fa4-4026-83bb-d75bae4ea99e}"
Private Const IID_IAsyncInfo As String = "{00000036-0000-0000-c000-000000000046}"

Private Const IID_IStream As String = "{0000000c-0000-0000-c000-000000000046}"
Private Const IID_IDXGIDevice As String = "{54ec77fa-1377-44e6-8c32-88fd5f44c84c}"
Private Const IID_IDirect3DDevice As String = "{a37624ab-8d5f-4650-9d3e-9eae3d9bc670}"
Private Const IID_IInitializeWithWindow As String = "{3e68d4bd-7135-4d10-8018-9fb6d9f33fa1}"

Private Const WindowsGraphicsCaptureGraphicsCaptureSession As String = "Windows.Graphics.Capture.GraphicsCaptureSession"
Private Const IID_IGraphicsCaptureSession As String = "{814e42a9-f70f-4ad7-939b-fddcc6eb880d}"
Private Const IID_IGraphicsCaptureSession2 As String = "{2c39ae40-7d2e-5044-804e-8b6799d4cf9e}"
Private Const IID_IGraphicsCaptureSession3 As String = "{f2cdd966-22ae-5ea1-9596-3a289344c3be}" ' geht wohl erst ab Win11
Private Const IID_IGraphicsCaptureSessionStatics As String = "{2224a540-5974-49aa-b232-0882536f4cb5}"

' geht wohl erst ab Win11
Private Const WindowsGraphicsCaptureGraphicsCaptureAccess As String = "Windows.Graphics.Capture.GraphicsCaptureAccess"
Private Const IID_IGraphicsCaptureAccessStatics As String = "{743ed370-06ec-5040-a58a-901f0f757095}"

Private Const WindowsGraphicsCaptureGraphicsCapturePicker As String = "Windows.Graphics.Capture.GraphicsCapturePicker"
Private Const IID_IGraphicsCapturePicker As String = "{5a1711b3-ad79-4b4a-9336-1318fdde3539}"

Private Const WindowsGraphicsCaptureDirect3D11CaptureFramePool As String = "Windows.Graphics.Capture.Direct3D11CaptureFramePool"
Private Const IID_IDirect3D11CaptureFramePool As String = "{24eb6d22-1975-422e-82e7-780dbd8ddf24}"
Private Const IID_IDirect3D11CaptureFramePoolStatics As String = "{7784056a-67aa-4d53-ae54-1088d5a8ca21}"
Private Const IID_IDirect3D11CaptureFramePoolStatics2 As String = "{589b103f-6bbc-5df5-a991-02e28b3b66d5}"

Private Const IID_IPicture As String = "{7bf80981-bf32-101a-8bbb-00aa00300cab}"
Private Const IID_ID3D11Texture2D As String = "{6f15aaf2-d208-4e89-9ab4-489535d34f9c}"
Private Const IID_IDirect3DDxgiInterfaceAccess As String = "{A9B3D012-3DF2-4EE3-B8D1-8695F457D3C1}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IUnknown
    IUnknown_QueryInterface = 0
    IUnknown_Release = 2

    ' IInspectable
    IInspectable_GetIids = 3
    IInspectable_GetRuntimeClassName = 4
    IInspectable_GetTrustLevel = 5
    
    ' IAsyncInfo
    IAsyncInfo_GetStatus = 7
    IAsyncInfo_Close = 10

    ' IAsyncInterface
    IAsyncInterface_GetResults = 8
    
    ' IClosable
    IClosable_Close = 6
    
    ' IInitializeWithWindow
    IInitializeWithWindow_Initialize = 3
    
    ' IGraphicsCaptureSessionStatics
    IGraphicsCaptureSessionStatics_IsSupported = 6
    
    ' IGraphicsCapturePicker
    IGraphicsCapturePicker_PickSingleItemAsync = 6
    
    ' IGraphicsCaptureItem
    IGraphicsCaptureItem_GetDisplayName = 6
    IGraphicsCaptureItem_GetSize = 7
    
    ' IDirect3D11CaptureFramePoolStatics
    IDirect3D11CaptureFramePoolStatics_Create = 6
    
    ' IDirect3D11CaptureFramePoolStatics2
    IDirect3D11CaptureFramePoolStatics2_CreateFreeThreaded = 6
    
    ' IDirect3D11CaptureFramePool
    IDirect3D11CaptureFramePool_TryGetNextFrame = 7
    IDirect3D11CaptureFramePool_CreateCaptureSession = 10

    ' IGraphicsCaptureSession
    IGraphicsCaptureSession_StartCapture = 6
    
    ' IGraphicsCaptureSession2
    IGraphicsCaptureSession2_GetIsCursorCaptureEnabled = 6
    IGraphicsCaptureSession2_PutIsCursorCaptureEnabled = 7
    
    ' IGraphicsCaptureSession3
    IGraphicsCaptureSession3_GetIsBorderRequired = 6 ' geht wohl erst ab Win11
    IGraphicsCaptureSession3_PutIsBorderRequired = 7 ' geht wohl erst ab Win11
    
    ' IGraphicsCaptureAccessStatics
    IGraphicsCaptureAccessStatics_RequestAccessAsync = 6 ' geht wohl erst ab Win11
    
    ' IDirect3D11CaptureFrame
    IDirect3D11CaptureFrame_GetSurface = 6
    
    ' IDirect3DDxgiInterfaceAccess
    IDirect3DDxgiInterfaceAccess_GetInterface = 3
    
    ' ID3D11Texture2D
    ID3D11Texture2D_GetDesc = 10
    
    ' ID3D11Device
    ID3D11Device_CreateTexture2D = 5
    
    ' ID3D11DeviceContext
    ID3D11DeviceContext_Map = 14
    ID3D11DeviceContext_Unmap = 15
    ID3D11DeviceContext_CopyResource = 47
    
End Enum

Private Enum GraphicsCaptureAccessKind
    GraphicsCaptureAccessKind_Borderless = 0
    GraphicsCaptureAccessKind_Programmatic = 1
End Enum

Private Enum asyncStatus
    Started = 0
    Completed = 1
    Canceled = 2
    Error = 3
End Enum

Private Enum TrustLevel
    BaseTrust = 0
    PartialTrust = 1
    FullTrust = 2
End Enum

Private Enum Status
    OK = 0
    GenericError = 1
    InvalidParameter = 2
    OutOfMemory = 3
    ObjectBusy = 4
    InsufficientBuffer = 5
    NotImplemented = 6
    Win32Error = 7
    WrongState = 8
    Aborted = 9
    FileNotFound = 10
    ValueOverflow = 11
    AccessDenied = 12
    UnknownImageFormat = 13
    FontFamilyNotFound = 14
    FontStyleNotFound = 15
    NotTrueTypeFont = 16
    UnsupportedGdiplusVersion = 17
    GdiplusNotInitialized = 18
    PropertyNotFound = 19
    PropertyNotSupported = 20
    ProfileNotFound = 21
End Enum

Private Enum DirectXPixelFormat 'DXGI_FORMAT
    Unknown = 0
    R32G32B32A32Typeless = 1
    R32G32B32A32Float = 2
    R32G32B32A32UInt = 3
    R32G32B32A32Int = 4
    R32G32B32Typeless = 5
    R32G32B32Float = 6
    R32G32B32UInt = 7
    R32G32B32Int = 8
    R16G16B16A16Typeless = 9
    R16G16B16A16Float = 10
    R16G16B16A16UIntNormalized = 11
    R16G16B16A16UInt = 12
    R16G16B16A16IntNormalized = 13
    R16G16B16A16Int = 14
    R32G32Typeless = 15
    R32G32Float = 16
    R32G32UInt = 17
    R32G32Int = 18
    R32G8X24Typeless = 19
    D32FloatS8X24UInt = 20
    R32FloatX8X24Typeless = 21
    X32TypelessG8X24UInt = 22
    R10G10B10A2Typeless = 23
    R10G10B10A2UIntNormalized = 24
    R10G10B10A2UInt = 25
    R11G11B10Float = 26
    R8G8B8A8Typeless = 27
    R8G8B8A8UIntNormalized = 28
    R8G8B8A8UIntNormalizedSrgb = 29
    R8G8B8A8UInt = 30
    R8G8B8A8IntNormalized = 31
    R8G8B8A8Int = 32
    R16G16Typeless = 33
    R16G16Float = 34
    R16G16UIntNormalized = 35
    R16G16UInt = 36
    R16G16IntNormalized = 37
    R16G16Int = 38
    R32Typeless = 39
    D32Float = 40
    R32Float = 41
    R32UInt = 42
    R32Int = 43
    R24G8Typeless = 44
    D24UIntNormalizedS8UInt = 45
    R24UIntNormalizedX8Typeless = 46
    X24TypelessG8UInt = 47
    R8G8Typeless = 48
    R8G8UIntNormalized = 49
    R8G8UInt = 50
    R8G8IntNormalized = 51
    R8G8Int = 52
    R16Typeless = 53
    R16Float = 54
    D16UIntNormalized = 55
    R16UIntNormalized = 56
    R16UInt = 57
    R16IntNormalized = 58
    R16Int = 59
    R8Typeless = 60
    R8UIntNormalized = 61
    R8UInt = 62
    R8IntNormalized = 63
    R8Int = 64
    A8UIntNormalized = 65
    R1UIntNormalized = 66
    R9G9B9E5SharedExponent = 67
    R8G8B8G8UIntNormalized = 68
    G8R8G8B8UIntNormalized = 69
    BC1Typeless = 70
    BC1UIntNormalized = 71
    BC1UIntNormalizedSrgb = 72
    BC2Typeless = 73
    BC2UIntNormalized = 74
    BC2UIntNormalizedSrgb = 75
    BC3Typeless = 76
    BC3UIntNormalized = 77
    BC3UIntNormalizedSrgb = 78
    BC4Typeless = 79
    BC4UIntNormalized = 80
    BC4IntNormalized = 81
    BC5Typeless = 82
    BC5UIntNormalized = 83
    BC5IntNormalized = 84
    B5G6R5UIntNormalized = 85
    B5G5R5A1UIntNormalized = 86
    B8G8R8A8UIntNormalized = 87
    B8G8R8X8UIntNormalized = 88
    R10G10B10XRBiasA2UIntNormalized = 89
    B8G8R8A8Typeless = 90
    B8G8R8A8UIntNormalizedSrgb = 91
    B8G8R8X8Typeless = 92
    B8G8R8X8UIntNormalizedSrgb = 93
    BC6HTypeless = 94
    BC6H16UnsignedFloat = 95
    BC6H16Float = 96
    BC7Typeless = 97
    BC7UIntNormalized = 98
    BC7UIntNormalizedSrgb = 99
    Ayuv = 100
    Y410 = 101
    Y416 = 102
    NV12 = 103
    P010 = 104
    P016 = 105
    Opaque420 = 106
    Yuy2 = 107
    Y210 = 108
    Y216 = 109
    NV11 = 110
    AI44 = 111
    IA44 = 112
    P8 = 113
    A8P8 = 114
    B4G4R4A4UIntNormalized = 115
    P208 = 130
    V208 = 131
    V408 = 132
    SamplerFeedbackMinMipOpaque = 189
    SamplerFeedbackMipRegionUsedOpaque = 190
End Enum

Private Enum PixelFormats
    PixelFormatUndefined = &H0&
    PixelFormatMax = &HF&
    PixelFormat16bppRGB555 = &H21005
    PixelFormat16bppRGB565 = &H21006
    PixelFormat16bppGrayScale = &H101004
    PixelFormat16bppARGB1555 = &H61007
    PixelFormat24bppRGB = &H21808
    PixelFormat32bppRGB = &H22009
    PixelFormat32bppARGB = &H26200A
    PixelFormat32bppPARGB = &HD200B
    PixelFormat48bppRGB = &H10300C
    PixelFormat64bppARGB = &H34400D
    PixelFormat64bppPARGB = &H1C400E
    PixelFormatGDI = &H20000
    PixelFormat1bppIndexed = &H30101
    PixelFormat4bppIndexed = &H30402
    PixelFormat8bppIndexed = &H30803
    PixelFormatAlpha = &H40000
    PixelFormatIndexed = &H10000
    PixelFormatPAlpha = &H80000
    PixelFormatExtended = &H100000
    PixelFormatCanonical = &H200000
End Enum

Private Enum D3D11_USAGE
    D3D11_USAGE_DEFAULT = 0
    D3D11_USAGE_IMMUTABLE = 1
    D3D11_USAGE_DYNAMIC = 2
    D3D11_USAGE_STAGING = 3
End Enum

Private Enum D3D11_CPU_ACCESS_FLAG
    D3D11_CPU_ACCESS_WRITE = &H10000
    D3D11_CPU_ACCESS_READ = &H20000
End Enum

Private Enum D3D11_BIND_FLAG
    D3D11_BIND_DEFAULT = &H0&
    D3D11_BIND_VERTEX_BUFFER = &H1&
    D3D11_BIND_INDEX_BUFFER = &H2&
    D3D11_BIND_CONSTANT_BUFFER = &H4&
    D3D11_BIND_SHADER_RESOURCE = &H8&
    D3D11_BIND_STREAM_OUTPUT = &H10&
    D3D11_BIND_RENDER_TARGET = &H20&
    D3D11_BIND_DEPTH_STENCIL = &H40&
    D3D11_BIND_UNORDERED_ACCESS = &H80&
    D3D11_BIND_DECODER = &H200&
    D3D11_BIND_VIDEO_ENCODER = &H400&
End Enum

Private Enum D3D11_RESOURCE_MISC_FLAG
    D3D11_RESOURCE_MISC_DEFAULT = &H0&
    D3D11_RESOURCE_MISC_GENERATE_MIPS = &H1&
    D3D11_RESOURCE_MISC_SHARED = &H2&
    D3D11_RESOURCE_MISC_TEXTURECUBE = &H4&
    D3D11_RESOURCE_MISC_DRAWINDIRECT_ARGS = &H1&
    D3D11_RESOURCE_MISC_BUFFER_ALLOW_RAW_VIEWS = &H2&
    D3D11_RESOURCE_MISC_BUFFER_STRUCTURED = &H4&
    D3D11_RESOURCE_MISC_RESOURCE_CLAMP = &H8&
    D3D11_RESOURCE_MISC_SHARED_KEYEDMUTEX = &H10&
    D3D11_RESOURCE_MISC_GDI_COMPATIBLE = &H20&
    D3D11_RESOURCE_MISC_SHARED_NTHANDLE = &H80&
    D3D11_RESOURCE_MISC_RESTRICTED_CONTENT = &H100&
    D3D11_RESOURCE_MISC_RESTRICT_SHARED_RESOURCE = &H200&
    D3D11_RESOURCE_MISC_RESTRICT_SHARED_RESOURCE_DRIVER = &H400&
    D3D11_RESOURCE_MISC_GUARDED = &H800&
    D3D11_RESOURCE_MISC_TILE_POOL = &H2000&
    D3D11_RESOURCE_MISC_TILED = &H4000&
    D3D11_RESOURCE_MISC_HW_PROTECTED = &H8000&
End Enum

Private Enum D3D11_MAP
    D3D11_MAP_READ = 1
    D3D11_MAP_WRITE = 2
    D3D11_MAP_READ_WRITE = 3
    D3D11_MAP_WRITE_DISCARD = 4
    D3D11_MAP_WRITE_NO_OVERWRITE = 5
End Enum

' ----==== Types ====----
Private Type GUID
    data1 As Long
    data2 As Long
    data3 As Long
    data4 As Long
End Type

Private Type PictDesc
    cbSizeofStruct As Long
    picType As Long
    hImage As Long
    xExt As Long
    yExt As Long
End Type

Private Type SizeInt32
    Width As Long
    Height As Long
End Type

Private Type TimeSpan
    Duration As Currency
End Type

Private Type DXGI_SAMPLE_DESC
  Count As Long
  Quality As Long
End Type

Private Type D3D11_TEXTURE2D_DESC
    Width As Long
    Height As Long
    MipLevels As Long
    ArraySize As Long
    Format As Long 'DXGI_FORMAT
    SampleDesc As DXGI_SAMPLE_DESC
    Usage As D3D11_USAGE
    BindFlags As D3D11_BIND_FLAG
    CPUAccessFlags As D3D11_CPU_ACCESS_FLAG
    MiscFlags As D3D11_RESOURCE_MISC_FLAG
End Type

Private Type D3D11_MAPPED_SUBRESOURCE
    pData As Long
    RowPitch As Long
    DepthPitch As Long
End Type

Private Type GDIPlusStartupInput
    GdiPlusVersion As Long
    DebugEventCallback As Long
    SuppressBackgroundThread As Long
    SuppressExternalCodecs As Long
End Type

Private Type GdiplusStartupOutput
    NotificationHook As Long
    NotificationUnhook As Long
End Type

' ----==== Ole32.dll Declarations ====----
Private Declare Function CLSIDFromString Lib "ole32.dll" ( _
                         ByVal pstring As Long, _
                         ByRef pCLSID As GUID) As Long
                         
Private Declare Function StringFromGUID Lib "ole32.dll" _
                         Alias "StringFromGUID2" ( _
                         ByRef rguid As GUID, _
                         ByVal lpsz As Long, _
                         ByVal cchMax As Long) As Long
                         
Private Declare Sub CoTaskMemFree Lib "ole32.dll" ( _
                    ByVal hMem As Long)
                         
' ----==== Oleaut32.dll Declarations ====----
Private Declare Function DispCallFunc Lib "Oleaut32.dll" ( _
                         ByVal pvInstance As Long, _
                         ByVal oVft As Long, _
                         ByVal cc As Long, _
                         ByVal vtReturn As VbVarType, _
                         ByVal cActuals As Long, _
                         ByVal prgvt As Any, _
                         ByVal prgpvarg As Any, _
                         ByRef pvargResult As Variant) As Long

Private Declare Function OleCreatePictureIndirect Lib "Oleaut32.dll" ( _
                         ByRef lpPictDesc As PictDesc, _
                         ByRef riid As GUID, _
                         ByVal fOwn As Long, _
                         ByRef lplpvObj As Object) As Long

' ----==== User32.dll Declarations ====----
Private Declare Function FindWindow Lib "User32.dll" _
                         Alias "FindWindowW" ( _
                         ByVal lpClassName As Long, _
                         ByVal lpWindowName As Long) As Long
                         
Private Declare Function GetWindowLong Lib "User32.dll" _
                         Alias "GetWindowLongA" ( _
                         ByVal hwnd As Long, _
                         ByVal nIndex As Long) As Long

' ----==== Kernel32.dll Declarations ====----
Private Declare Sub CopyMemory Lib "Kernel32.dll" _
                    Alias "RtlMoveMemory" ( _
                    ByRef pTo As Any, _
                    ByRef uFrom As Any, _
                    ByVal lSize As Long)

Private Declare Function lstrlenW Lib "Kernel32.dll" ( _
                         ByVal lpString As Long) As Long

' ----==== Combase.dll Declarations ====----
Private Declare Function WindowsCreateString Lib "Combase.dll" ( _
                         ByVal sourceString As Long, _
                         ByVal lenght As Long, _
                         ByRef hString As Long) As Long

Private Declare Function WindowsGetStringRawBuffer Lib "Combase.dll" ( _
                         ByVal sourceString As Long, _
                         ByRef length As Long) As Long

Private Declare Function WindowsDeleteString Lib "Combase.dll" ( _
                         ByVal sourceString As Long) As Long

Private Declare Function RoGetActivationFactory Lib "Combase.dll" ( _
                         ByVal activatableClassId As Long, _
                         ByRef riid As GUID, _
                         ByRef factory As Long) As Long

Private Declare Function RoActivateInstance Lib "Combase.dll" ( _
                         ByVal activatableClassId As Long, _
                         ByRef instance As Long) As Long

' ----==== D3D11.dll Declarations ====----
Private Declare Function D3D11CreateDevice Lib "D3D11.dll" ( _
                         ByVal pAdapter As Long, _
                         ByVal DriverType As Long, _
                         ByVal Software As Long, _
                         ByVal flags As Long, _
                         ByVal pfeatureLevels As Long, _
                         ByVal featureLevels As Long, _
                         ByVal SDKVersion As Long, _
                         ByRef ppDevice As Long, _
                         ByRef pFeatureLevel As Long, _
                         ByRef ppImmediateContext As Long) As Long

Private Declare Function CreateDirect3D11DeviceFromDXGIDevice Lib "D3D11.dll" ( _
                         ByVal dxgiDevice As Long, _
                         ByRef graphicsDevice As Long) As Long

' ----==== Gdiplus.dll Declarations ====----
Private Declare Function GdiplusShutdown Lib "GdiPlus.dll" ( _
                         ByVal token As Long) As Status
                         
Private Declare Function GdiplusStartup Lib "GdiPlus.dll" ( _
                         ByRef token As Long, _
                         ByRef lpInput As GDIPlusStartupInput, _
                         ByRef lpOutput As GdiplusStartupOutput) As Status

Private Declare Function GdipCreateBitmapFromScan0 Lib "GdiPlus.dll" ( _
                         ByVal mWidth As Long, _
                         ByVal mHeight As Long, _
                         ByVal mStride As Long, _
                         ByVal mPixelFormat As Long, _
                         ByVal mScan0 As Long, _
                         ByRef mBitmap As Long) As Status
                         
Private Declare Function GdipDisposeImage Lib "GdiPlus.dll" ( _
                         ByVal image As Long) As Status

Private Declare Function GdipCreateHBITMAPFromBitmap Lib "GdiPlus.dll" ( _
                         ByVal mBitmap As Long, _
                         ByRef mHbmReturn As Long, _
                         ByVal mBackground As Long) As Status
                         
Private Declare Function GdipSaveImageToFile Lib "GdiPlus.dll" ( _
                         ByVal image As Long, _
                         ByVal FileName As Long, _
                         ByRef clsidEncoder As GUID, _
                         ByRef encoderParams As Any) As Status
                         
' ----==== Variablen ====----
Private m_bmpRet As StdPicture
Private m_lngGdipToken As Long
Private m_bolIsInitialized As Boolean
Private m_bolIsCapturePickerCreated As Boolean

Private m_pIGraphicsCapturePicker As Long

' ----==== Events ====----

' ----==== Class ====----
Private Sub Class_Initialize()
    m_bolIsInitialized = False
    m_bolIsCapturePickerCreated = False
    Dim pIGraphicsCaptureSessionStatics As Long
    If GetActivationFactory(WindowsGraphicsCaptureGraphicsCaptureSession, _
                            IID_IGraphicsCaptureSessionStatics, _
                            pIGraphicsCaptureSessionStatics) Then
        Dim bolIsSupported As Boolean
        If Invoke(pIGraphicsCaptureSessionStatics, _
                  IGraphicsCaptureSessionStatics_IsSupported, _
                  VarPtr(bolIsSupported)) = S_OK Then
            If bolIsSupported Then
                If GetActivateInstance(WindowsGraphicsCaptureGraphicsCapturePicker, _
                                       IID_IGraphicsCapturePicker, _
                                       m_pIGraphicsCapturePicker) Then
                    Dim tGdipStartupInput As GDIPlusStartupInput
                    Dim tGdipStartupOutput As GdiplusStartupOutput
                    tGdipStartupInput.GdiPlusVersion = GdiPlusVersion
                    If GdiplusStartup(m_lngGdipToken, tGdipStartupInput, _
                                      tGdipStartupOutput) = OK Then
                        m_bolIsInitialized = True

                    End If
                End If
            End If
        End If
        Call Release(pIGraphicsCaptureSessionStatics)
    End If
End Sub

Private Sub Class_Terminate()
    Call Release(m_pIGraphicsCapturePicker)
    If m_lngGdipToken <> 0& Then Call GdiplusShutdown(m_lngGdipToken)
    m_bolIsInitialized = False
    m_bolIsCapturePickerCreated = False
End Sub

' ----==== Properties ====----
Public Property Get IsInitialized() As Boolean
    IsInitialized = m_bolIsInitialized
End Property

Public Property Get CapturePicture() As StdPicture
    Set CapturePicture = m_bmpRet
End Property

Public Property Get IsCapturePickerCreated() As Boolean
    IsCapturePickerCreated = m_bolIsCapturePickerCreated
End Property

' ----==== Subs & Functions ====----
Public Function CreateCapturePicker(ByVal OwnerHwnd As Long) As Boolean
    Dim bolRet As Boolean
    bolRet = False
    If Me.IsInitialized Then
        Dim pIInitializeWithWindow As Long
        If Invoke(m_pIGraphicsCapturePicker, IUnknown_QueryInterface, _
                  VarPtr(Str2Guid(IID_IInitializeWithWindow)), _
                  VarPtr(pIInitializeWithWindow)) = S_OK Then
            If Invoke(pIInitializeWithWindow, IInitializeWithWindow_Initialize, _
                      OwnerHwnd) = S_OK Then
                bolRet = True
                m_bolIsCapturePickerCreated = True
            End If
            Call Release(pIInitializeWithWindow)
        End If
    End If
    CreateCapturePicker = bolRet
End Function

Public Function PickSingleItemAsync() As Boolean
    Dim bolRet As Boolean
    Dim bolWasMinimized As Boolean
    bolRet = False
    bolWasMinimized = False
    If Me.IsCapturePickerCreated Then
        Dim pIGraphicsCaptureItem As Long
        If Invoke(m_pIGraphicsCapturePicker, IGraphicsCapturePicker_PickSingleItemAsync, _
                  VarPtr(pIGraphicsCaptureItem)) = S_OK Then
            If WaitForAsync(pIGraphicsCaptureItem) Then
                If pIGraphicsCaptureItem <> 0& Then
                    Dim tSizeInt32 As SizeInt32
                    If Invoke(pIGraphicsCaptureItem, IGraphicsCaptureItem_GetSize, VarPtr(tSizeInt32)) = S_OK Then
                        If tSizeInt32.Width <> 0& And tSizeInt32.Height <> 0& Then
                            bolRet = True
                            Dim hString As Long
                            If Invoke(pIGraphicsCaptureItem, IGraphicsCaptureItem_GetDisplayName, VarPtr(hString)) = S_OK Then
                                Dim hwnd As Long
                                hwnd = FindWindow(0&, WindowsGetStringRawBuffer(hString, 0&))
                                If hwnd <> 0& Then
                                    If CBool(GetWindowLong(hwnd, GWL_STYLE) And WS_MINIMIZE) Then
                                        bolRet = False
                                        MsgBox "Von diesem Fenster kann kein Screenshot erstellt werden da es minimiert ist."
                                    End If
                                End If
                            End If
                        Else
                            MsgBox "Von diesem Fenster kann kein Screenshot erstellt werden."
                        End If
                    End If
                    If bolRet Then Call StartCapture(pIGraphicsCaptureItem)
                End If
            End If
            Call Release(pIGraphicsCaptureItem)
        End If
    End If
    PickSingleItemAsync = bolRet
End Function

Private Sub StartCapture(ByVal pIGraphicsCaptureItem As Long)
    Dim pIDirect3D11CaptureFramePoolStatics As Long
    If GetActivationFactory(WindowsGraphicsCaptureDirect3D11CaptureFramePool, _
                            IID_IDirect3D11CaptureFramePoolStatics, _
                            pIDirect3D11CaptureFramePoolStatics) Then
        Dim tSizeInt32 As SizeInt32
        If Invoke(pIGraphicsCaptureItem, IGraphicsCaptureItem_GetSize, _
                  VarPtr(tSizeInt32)) = S_OK Then
            Dim pID3D11Device As Long
            Dim pID3D11DeviceContext As Long
            If D3D11CreateDevice(0&, D3D_DRIVER_TYPE_HARDWARE, 0&, _
                                 D3D11_CREATE_DEVICE_BGRA_SUPPORT, 0&, 0&, _
                                 D3D11_SDK_VERSION, pID3D11Device, 0&, _
                                 pID3D11DeviceContext) = S_OK Then
                Dim pIDXGIDevice As Long
                If Invoke(pID3D11Device, IUnknown_QueryInterface, _
                          VarPtr(Str2Guid(IID_IDXGIDevice)), _
                          VarPtr(pIDXGIDevice)) = S_OK Then
                    Dim pIInspectable As Long
                    If CreateDirect3D11DeviceFromDXGIDevice(pIDXGIDevice, pIInspectable) = S_OK Then
                        Dim pIDirect3DDevice As Long
                        If Invoke(pIInspectable, IUnknown_QueryInterface, _
                                  VarPtr(Str2Guid(IID_IDirect3DDevice)), _
                                  VarPtr(pIDirect3DDevice)) = S_OK Then
                            Dim pIDirect3D11CaptureFramePool As Long
                            If Invoke(pIDirect3D11CaptureFramePoolStatics, _
                                      IDirect3D11CaptureFramePoolStatics_Create, _
                                      pIDirect3DDevice, _
                                      DirectXPixelFormat.B8G8R8A8UIntNormalized, 1, _
                                      tSizeInt32.Width, tSizeInt32.Height, _
                                      VarPtr(pIDirect3D11CaptureFramePool)) = S_OK Then
                                Dim pIGraphicsCaptureSession As Long
                                If Invoke(pIDirect3D11CaptureFramePool, _
                                          IDirect3D11CaptureFramePool_CreateCaptureSession, _
                                          pIGraphicsCaptureItem, VarPtr(pIGraphicsCaptureSession)) = S_OK Then
                                    Dim pIGraphicsCaptureSession2 As Long
                                    If Invoke(pIGraphicsCaptureSession, _
                                              IUnknown_QueryInterface, VarPtr(Str2Guid(IID_IGraphicsCaptureSession2)), _
                                              VarPtr(pIGraphicsCaptureSession2)) = S_OK Then
                                        Dim bolIsCursorCaptureEnabled As Boolean
                                        If Invoke(pIGraphicsCaptureSession2, _
                                                  IGraphicsCaptureSession2_GetIsCursorCaptureEnabled, _
                                                  VarPtr(bolIsCursorCaptureEnabled)) = S_OK Then
                                            'Debug.Print "Cursor: " & bolIsCursorCaptureEnabled
                                        End If
                                        If Invoke(pIGraphicsCaptureSession2, _
                                                  IGraphicsCaptureSession2_PutIsCursorCaptureEnabled, _
                                                  bolIsCursorCaptureEnabled) = S_OK Then
                                            'Debug.Print "Cursor"
                                        End If
                                        Call Release(pIGraphicsCaptureSession2)
                                    End If
                                    
                                    
                                    ' geht wohl erst mit Win11 **********************************
                                    Dim pIGraphicsCaptureAccessStatics As Long
                                    If GetActivationFactory(WindowsGraphicsCaptureGraphicsCaptureAccess, _
                                                            IID_IGraphicsCaptureAccessStatics, _
                                                            pIGraphicsCaptureAccessStatics) Then
                                        Dim pIGraphicsCaptureSession3 As Long
                                        If Invoke(pIGraphicsCaptureSession, _
                                                  IUnknown_QueryInterface, VarPtr(Str2Guid(IID_IGraphicsCaptureSession3)), _
                                                  VarPtr(pIGraphicsCaptureSession3)) = S_OK Then
                                            Dim bolIsBorderRequired As Boolean
                                            If Invoke(pIGraphicsCaptureSession3, _
                                                      IGraphicsCaptureSession3_GetIsBorderRequired, _
                                                      VarPtr(bolIsBorderRequired)) = S_OK Then
                                                'Debug.Print "Border: " & bolIsBorderRequired
                                            End If
                                            If Invoke(pIGraphicsCaptureSession3, _
                                                      IGraphicsCaptureSession3_PutIsBorderRequired, _
                                                      bolIsBorderRequired) = S_OK Then
                                                'Debug.Print "Border"
                                            End If
                                            Call Release(pIGraphicsCaptureSession3)
                                        End If
                                        Call Release(pIGraphicsCaptureAccessStatics)
                                    End If
                                    ' ***********************************************************
                                    
                                    If Invoke(pIGraphicsCaptureSession, IGraphicsCaptureSession_StartCapture) = S_OK Then
                                        Do
                                            Dim pIDirect3D11CaptureFrame As Long
                                            If Invoke(pIDirect3D11CaptureFramePool, _
                                                      IDirect3D11CaptureFramePool_TryGetNextFrame, _
                                                      VarPtr(pIDirect3D11CaptureFrame)) = S_OK Then DoEvents
                                        Loop While pIDirect3D11CaptureFrame = 0&
                                        If pIDirect3D11CaptureFrame <> 0& Then
                                            Dim pIDirect3DSurface As Long
                                            If Invoke(pIDirect3D11CaptureFrame, _
                                                      IDirect3D11CaptureFrame_GetSurface, _
                                                      VarPtr(pIDirect3DSurface)) = S_OK Then
                                                Call GetImageFromIDirect3DSurface(pIDirect3DSurface, pID3D11Device, pID3D11DeviceContext)
                                                Call CloseAndRelease(pIDirect3DSurface)
                                            End If
                                            Call CloseAndRelease(pIDirect3D11CaptureFrame)
                                        End If
                                    End If
                                    Call CloseAndRelease(pIGraphicsCaptureSession)
                                End If
                                Call CloseAndRelease(pIDirect3D11CaptureFramePool)
                            End If
                            Call CloseAndRelease(pIDirect3DDevice)
                        End If
                        Call CloseAndRelease(pIInspectable)
                    End If
                    Call Release(pIDXGIDevice)
                End If
                Call Release(pID3D11Device)
                Call Release(pID3D11DeviceContext)
            End If
        End If
        Call Release(pIDirect3D11CaptureFramePoolStatics)
    End If
End Sub

Private Sub GetImageFromIDirect3DSurface(ByVal pIDirect3DSurface As Long, _
                                         ByVal pID3D11Device As Long, _
                                         ByVal pID3D11DeviceContext As Long)
    Dim pIDirect3DDxgiInterfaceAccess As Long
    If Invoke(pIDirect3DSurface, IUnknown_QueryInterface, _
              VarPtr(Str2Guid(IID_IDirect3DDxgiInterfaceAccess)), _
              VarPtr(pIDirect3DDxgiInterfaceAccess)) = S_OK Then
        Dim pID3D11Texture2D As Long
        If Invoke(pIDirect3DDxgiInterfaceAccess, _
                  IDirect3DDxgiInterfaceAccess_GetInterface, _
                  VarPtr(Str2Guid(IID_ID3D11Texture2D)), _
                  VarPtr(pID3D11Texture2D)) = S_OK Then
            Dim tD3D11_TEXTURE2D_DESC As D3D11_TEXTURE2D_DESC
            Call Invoke(pID3D11Texture2D, ID3D11Texture2D_GetDesc, VarPtr(tD3D11_TEXTURE2D_DESC))
            With tD3D11_TEXTURE2D_DESC
                .Usage = D3D11_USAGE_STAGING
                .BindFlags = D3D11_BIND_DEFAULT
                .MiscFlags = D3D11_RESOURCE_MISC_DEFAULT
                .CPUAccessFlags = D3D11_CPU_ACCESS_READ
            End With
            Dim pID3D11Texture2D_2 As Long
            If Invoke(pID3D11Device, ID3D11Device_CreateTexture2D, _
                      VarPtr(tD3D11_TEXTURE2D_DESC), 0&, _
                      VarPtr(pID3D11Texture2D_2)) = S_OK Then
                If Invoke(pID3D11DeviceContext, ID3D11DeviceContext_CopyResource, _
                          pID3D11Texture2D_2, pID3D11Texture2D) = S_OK Then
                    Dim tD3D11_MAPPED_SUBRESOURCE As D3D11_MAPPED_SUBRESOURCE
                    If Invoke(pID3D11DeviceContext, ID3D11DeviceContext_Map, pID3D11Texture2D_2, _
                              0&, D3D11_MAP.D3D11_MAP_READ, 0&, VarPtr(tD3D11_MAPPED_SUBRESOURCE)) = S_OK Then
                        Dim pBitmap As Long
                        If GdipCreateBitmapFromScan0(tD3D11_TEXTURE2D_DESC.Width, tD3D11_TEXTURE2D_DESC.Height, _
                                                     tD3D11_MAPPED_SUBRESOURCE.RowPitch, PixelFormats.PixelFormat32bppARGB, _
                                                     tD3D11_MAPPED_SUBRESOURCE.pData, pBitmap) = OK Then
                        
                            ' oder halt als Bild speichern
                            'Debug.Print GdipSaveImageToFile(pBitmap, StrPtr("D:\CapturePicture.png"), Str2Guid(CLSID_GDIPPngEncoder), ByVal 0&)
                        
                            Dim hBitmap As Long
                            If GdipCreateHBITMAPFromBitmap(pBitmap, hBitmap, &HFFFFFFFF) = OK Then
                                Dim tPictDesc As PictDesc
                                With tPictDesc
                                    .cbSizeofStruct = Len(tPictDesc)
                                    .picType = vbPicTypeBitmap
                                    .hImage = hBitmap
                                End With
                                Dim oPicture As IPicture
                                If OleCreatePictureIndirect(tPictDesc, Str2Guid(IID_IPicture), _
                                                            API_TRUE, oPicture) = S_OK Then
                                    If Not oPicture Is Nothing Then
                                        Set m_bmpRet = oPicture
                                        Set oPicture = Nothing
                                    End If
                                End If
                            End If
                            Call GdipDisposeImage(pBitmap)
                        End If
                        Call Invoke(pID3D11DeviceContext, ID3D11DeviceContext_Unmap, pID3D11Texture2D_2, 0&)
                    End If
                End If
                Call Release(pID3D11Texture2D_2)
            End If
            Call Release(pID3D11Texture2D)
        End If
        Call Release(pIDirect3DDxgiInterfaceAccess)
    End If
End Sub

Private Function GetActivationFactory(ByVal ClassName As String, _
                                      ByVal iid As String, _
                                      ByRef pFactory As Long) As Boolean
    Dim bolRet As Boolean
    bolRet = False
    Dim hString As Long
    If WindowsCreateString(StrPtr(ClassName), Len(ClassName), hString) = S_OK Then
        If hString <> 0& Then
            If RoGetActivationFactory(hString, Str2Guid(iid), pFactory) = S_OK Then bolRet = True
            Call WindowsDeleteString(hString)
        End If
    End If
    GetActivationFactory = bolRet
End Function

Private Function GetActivateInstance(ByVal ClassName As String, _
                                     ByVal iid As String, _
                                     ByRef pInstance As Long) As Boolean
    Dim bolRet As Boolean
    bolRet = False
    Dim hString As Long
    If WindowsCreateString(StrPtr(ClassName), Len(ClassName), hString) = S_OK Then
        If hString <> 0& Then
            Dim pIInspectable As Long
            If RoActivateInstance(hString, pIInspectable) = S_OK Then
                If pIInspectable <> 0& Then
                    If Invoke(pIInspectable, IUnknown_QueryInterface, _
                              VarPtr(Str2Guid(iid)), VarPtr(pInstance)) = S_OK Then
                        If pInstance <> 0& Then bolRet = True
                    End If
                    Call Release(pIInspectable)
                End If
            End If
            Call WindowsDeleteString(hString)
        End If
    End If
    GetActivateInstance = bolRet
End Function

Private Function WaitForAsync(ByRef pInterface As Long) As Boolean
    Dim bolRet As Boolean
    bolRet = False
    If pInterface <> 0& Then
        Dim pIAsyncInfo As Long
        If Invoke(pInterface, IUnknown_QueryInterface, _
                  VarPtr(Str2Guid(IID_IAsyncInfo)), _
                  VarPtr(pIAsyncInfo)) = S_OK Then
            Dim eStatus As asyncStatus
            Do
                If Invoke(pIAsyncInfo, IAsyncInfo_GetStatus, _
                          VarPtr(eStatus)) = S_OK Then DoEvents
            Loop While eStatus = Started
            If eStatus = Completed Then
                bolRet = True
            Else
                Call Invoke(pIAsyncInfo, IAsyncInfo_Close)
            End If
            Call Release(pIAsyncInfo)
            If bolRet Then
                Dim pRet As Long
                If Invoke(pInterface, IAsyncInterface_GetResults, VarPtr(pRet)) = S_OK Then
                    Call Release(pInterface)
                    pInterface = pRet
                End If
            Else
                Call Release(pInterface)
            End If
        End If
    End If
    WaitForAsync = bolRet
End Function

Private Sub Release(ByRef pInterface As Long)
    Dim lngRet As Long
    If pInterface <> 0& Then
        Call Invoke(pInterface, IUnknown_Release)
        pInterface = 0&
    End If
End Sub

Private Function CloseAndRelease(ByRef pInterface As Long) As Long
    Dim lngRet As Long
    If pInterface <> 0& Then
        Dim pIClosable As Long
        If Invoke(pInterface, IUnknown_QueryInterface, _
                  VarPtr(Str2Guid(IID_IClosable)), _
                  VarPtr(pIClosable)) = S_OK Then
            Call Invoke(pIClosable, IClosable_Close)
            Call Release(pIClosable)
            Call Release(pInterface)
        End If
    End If
    CloseAndRelease = lngRet
End Function

Private Sub GetInspectableInfo(ByVal pInspectableInterface As Long, _
                               ByVal strInterface As String)
    If pInspectableInterface <> 0& Then
        Debug.Print "Inspectable Info for: " & strInterface
        Debug.Print "RuntimeClassName = " & GetInspectable_GetRuntimeClassName(pInspectableInterface)
        Dim eTrustLevel As TrustLevel
        eTrustLevel = GetInspectable_GetTrustLevel(pInspectableInterface)
        Select Case eTrustLevel
            Case TrustLevel.BaseTrust
                Debug.Print "TrustLevel = BaseTrust"
            Case TrustLevel.FullTrust
                Debug.Print "TrustLevel = FullTrust"
            Case TrustLevel.PartialTrust
                Debug.Print "TrustLevel = PartialTrust"
            Case Else
                Debug.Print "TrustLevel = UnknownTrust"
        End Select
        Dim tIIDs() As GUID
        Dim lngIIDsCount As Long
        lngIIDsCount = GetInspectable_GetIIDs(pInspectableInterface, tIIDs)
        Debug.Print "AviableIIDsCount = " & CStr(lngIIDsCount)
        If lngIIDsCount > 0 Then
            Dim lngIIDsItem As Long
            For lngIIDsItem = 0 To lngIIDsCount - 1
                Debug.Print "    AviableIID " & CStr(lngIIDsItem + 1) & _
                            " = " & Guid2Str(tIIDs(lngIIDsItem))
            Next
        End If
        Debug.Print String(60, "-")
    End If
End Sub

Private Function GetInspectable_GetIIDs(ByVal pInterface As Long, _
                                        ByRef tIIDs() As GUID) As Long
    Dim lngIIDCount As Long
    If pInterface <> 0& Then
        Dim pIIDs As Long
        If Invoke(pInterface, IInspectable_GetIids, _
                  VarPtr(lngIIDCount), VarPtr(pIIDs)) = S_OK Then
            If lngIIDCount > 0 Then
                Dim lngBytes As Long
                Dim lngIIDItem As Long
                ReDim tIIDs(lngIIDCount - 1)
                For lngIIDItem = 0 To lngIIDCount - 1
                    lngBytes = Len(tIIDs(lngIIDItem))
                    Call CopyMemory(tIIDs(lngIIDItem), _
                                    ByVal pIIDs + (lngBytes * lngIIDItem), _
                                    lngBytes)
                Next
            End If
        End If
    End If
    GetInspectable_GetIIDs = lngIIDCount
End Function

Private Function GetInspectable_GetRuntimeClassName(ByVal pInterface As Long) As String
    Dim strRet As String
    If pInterface <> 0& Then
        Dim pStr As Long
        If Invoke(pInterface, IInspectable_GetRuntimeClassName, _
                  VarPtr(pStr)) = S_OK Then
            If pStr <> 0& Then strRet = Ptr2Str(pStr)
        End If
    End If
    GetInspectable_GetRuntimeClassName = strRet
End Function

Private Function GetInspectable_GetTrustLevel(ByVal pInterface As Long) As TrustLevel
    Dim eRet As TrustLevel
    If pInterface <> 0& Then
        Dim lngValue As Long
        If Invoke(pInterface, IInspectable_GetTrustLevel, _
                  VarPtr(lngValue)) = S_OK Then
            eRet = lngValue
        End If
    End If
    GetInspectable_GetTrustLevel = eRet
End Function

Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function

Private Function OleInvoke(ByVal pInterface As Long, _
                           ByVal lngCmd As Long, _
                           ParamArray aParam()) As Variant
    If pInterface <> 0& Then
        If UBound(aParam) >= 0& Then
            Dim varParam As Variant
            varParam = aParam
            If IsArray(varParam) Then varParam = varParam(0)
            Dim lngCount As Long
            lngCount = UBound(varParam)
            Dim lngItem As Long
            Dim olePtr(10) As Long
            Dim oleTyp(10) As Integer
            For lngItem = 0& To lngCount
                oleTyp(lngItem) = VarType(varParam(lngItem))
                olePtr(lngItem) = VarPtr(varParam(lngItem))
            Next
        End If
        Dim varRet As Variant
        If DispCallFunc(pInterface, lngCmd * 4, CC_STDCALL, _
                        vbLong, lngItem, VarPtr(oleTyp(0)), _
                        VarPtr(olePtr(0)), varRet) <> S_OK Then
            Debug.Print "Fehler beim Aufrufen der Interface-Funktion!"
        End If

'        If varRet <> S_OK Then
'            Debug.Print "0x" & Hex$(varRet)
'        End If
    End If
    OleInvoke = varRet
End Function

Private Function Str2Guid(ByVal strGUID As String) As GUID
    Call CLSIDFromString(StrPtr(strGUID), Str2Guid)
End Function

Private Function Guid2Str(ByRef tGUID As GUID) As String
    Dim lngRet As Long
    Dim strGUID As String
    strGUID = String(40, 0)
    lngRet = StringFromGUID(tGUID, StrPtr(strGUID), Len(strGUID))
    If lngRet > 0 Then
        strGUID = Left$(strGUID, lngRet - 1)
    Else
        strGUID = vbNullString
    End If
    Guid2Str = strGUID
End Function

Private Function Ptr2Str(ByVal lpStr As Long) As String
    Dim lngLen As Long
    Dim bytBuffer() As Byte
    lngLen = lstrlenW(lpStr) * 2
    If lngLen > 0 Then
        ReDim bytBuffer(lngLen - 1)
        Call CopyMemory(bytBuffer(0), ByVal lpStr, lngLen)
        Call CoTaskMemFree(lpStr)
        Ptr2Str = bytBuffer
    End If
End Function
